#!/bin/bash

##Newman's method

awk '
{
	deg[$1]+=1;
	deg[$2]+=1
}
END{
	for(i in deg){
		print i,deg[i]
	}
}
' config.dat | sort -k2gr > deg.dat


awk -f - deg.dat config.dat > dl.dat <<EOF
	FILENAME == ARGV[1]{deg[\$1]=\$2}
	FILENAME == ARGV[2]{print deg[\$2],deg[\$1]}
EOF


ss=`wc -l dl.dat | awk '{print $1}'`


awk '{
	a+=$1*$2;
	b+=$1*$1+$2*$2;
	c+=$1+$2
}
END{
	print (4*'$ss'*a-c*c)/(2*'$ss'*b-c*c)
}
' dl.dat


rm deg.dat dl.dat
